Changelog
=========

All changes in the package are documented at https://github.com/ckeditor/ckeditor5/blob/master/CHANGELOG.md.

Changes for the past releases are available below.


## 23.0.0 (September 25, 2020)

### Features

* Introduced support for [importing documents and receiving initial data from the Cloud Services server](https://help.cke-cs.com/api/v4/docs#tag/Collaboration/paths/~1collaborations/post) in real-time collaborative editing.


## 22.0.0 (August 25, 2020)

Internal changes only (updated dependencies, documentation, etc.).


## 21.0.0 (July 24, 2020)

### Features

* Enabled multi-cell table selection in real-time collaboration.


## 20.0.1 (June 26, 2020)

Internal changes only (updated dependencies, documentation, etc.).


## 19.0.2 (May 25, 2020)

Internal changes only (updated dependencies, documentation, etc.).


## 19.0.1 (April 30, 2020)

### Features

* Localized the UI for real-time collaboration plugins.

### Bug fixes

* User selection marker will now be properly removed when the user switches to a different editor instance or a form field.


## 18.0.0 (March 19, 2020)

### Bug fixes

* Connection errors will no longer permanently crash the editor in Firefox and Safari.
* Introduced a synchronization mechanism to fixed comments feature errors happening after reconnecting to the document.
* Fixed editor crash in track changes feature happening in scenarios involving reconnection.
* Fixed issues with editor data, comments and presence list not being properly updated after the editor reconnected to the real-time collaboration server.


## 17.0.0 (February 20, 2020)

### BREAKING CHANGES

* Real-time collaboration features now expect the `config.collaboration.channelId` configuration parameter. The previously used `config.cloudServices.documentId` was deprecated and will be removed in the next release.
* `Sessions#connectedUsers` was replaced with `Sessions#allConnectedUsers`. `Sessions#sessions` was replaced with `Sessions#channelSessions`. `Sessions#getUserSessions()` now requires a second parameter, `channelId`. `Sessions#channelConnectedUsers` is now available to get users connected only to a given channel.
* If you use `Context` in your application, context plugins should be added to the context configuration instead of the editor configuration. The following plugins were changed to context plugins:
  * `Sessions`,
  * `PresenceList`,
  * `CloudServicesCommentsAdapter`. Note that `CloudServicesCommentsAdapter` needs to be added to the context configuration even if you are passing real-time collaboration plugins in the editor configuration.


### Features

* Introduced the `config.cloudServices.bundleVersion` configuration parameter.

### Other changes

* The sessions plugin was changed to a context plugin and now handles connection to multiple channel IDs.
* Presence list became a context plugin and will show all users connected to all editor instances operating in the same context.


## 16.0.0 (December 2, 2019)

### Other changes

* Introduced a mechanism that restarts the WebSocket connection during its initialization when an error occurs.


## 15.0.0 (October 23, 2019)

### Features

* Introduced the [`collapseAt`](https://ckeditor.com/docs/ckeditor5/latest/features/collaboration/real-time-collaboration/users-in-real-time-collaboration.html#installation-and-configuration) configuration option which defines when the presence list should get collapsed.

### Bug fixes

* Fixed a bug causing users to be missing in the users' dropdown.

### Other changes

* The editor will now throw an error when the web socket URL is not defined in the real-time collaboration configuration.


## 12.4.0 (August 22, 2019)

### Features

* Assigned authors to operations. See the [documentation](https://ckeditor.com/docs/ckeditor5/latest/features/collaboration/users.html#operation-authors).
* Introduced the writer, reader and commentator roles. See the [documentation](https://ckeditor.com/docs/ckeditor5/latest/features/collaboration/real-time-collaboration/users-in-real-time-collaboration.html#user-roles).

### Bug fixes

* Receiving operations will not be blocked when the second client has joined while the editor is read-only.
* Improved stabilization of connecting to the document.
* Prevented applying the same operation from the server twice in some scenarios when the client is having ping-pong communication with the server.

### Other changes

* Removed crash events and made the code throw a `CKEditorError` instead.


## 12.3.0 (July 4, 2019)

### Features

* Added support for the [track changes feature](https://ckeditor.com/collaboration/track-changes/) in real-time collaboration. Introduced the `RealTimeCollaborativeTrackChanges` plugin.
* Provided an API for adding `onClick` actions for the presence list members.

### Bug fixes

* Operations should be resent to the server with a delay after the server response was handled.

### Other changes

* Introduced the support for mobile environments: Android and iOS.


## 12.2.1 (June 5, 2019)

Internal changes only (updated dependencies, documentation, etc.).


## 12.2.0 (April 4, 2019)

### Features

* Added support for [multi-root editor](https://github.com/ckeditor/ckeditor5-collaboration-samples/tree/master/multi-root-editor-with-real-time-collaboration).

### Bug fixes

* Prevented typing inside other users' markers in an image caption.

### Other changes

* The `editor.data.set()` method will throw an exception in real-time collaboration if used without the `suppressErrorInCollaboration` flag to prevent common mistakes with real-time editing integration.


## 12.1.0 (February 5, 2019)

* Introduced the new Cloud Features Comments adapter which fixes multiple bugs related to comments in real-time editing.
* The editor now throws an error when it is initialized on multiple root editable elements.


## 12.0.1 (December 6, 2018)

### Bug fixes

* Update dependencies versions.


## 12.0.0 (December 6, 2018)

Since the family of CKEditor&nbsp;5 collaboration features was expanded, the structure of repositories was rearranged. The "CKEditor&nbsp;5 collaboration" package was renamed to "CKEditor&nbsp;5 real-time collaboration" and a part of it was extracted to separate repositories: [CKEditor&nbsp;5 collaboration core](https://www.npmjs.com/package/@ckeditor/ckeditor5-collaboration-core) and [CKEditor&nbsp;5 comments](https://www.npmjs.com/package/@ckeditor/ckeditor5-comments).

It means that all packages use different paths now and some of them (mostly users and comments) have a new API. In some cases, it is enough to add `-real-time-` to the import path, but it is recommended to refer to [the new guide about CKEditor&nbsp;5 real-time collaboration solutions](https://ckeditor.com/docs/ckeditor5/latest/features/collaboration/real-time-collaboration/real-time-collaboration.html) for more details.


## 11.0.0 (October 8, 2018)

### New operational transformation algorithms

Real-time collaboration is now based on [new operational transformation algorithms introduced in the CKEditor&nbsp;5 engine](https://github.com/ckeditor/ckeditor5-engine/issues/1162). This change makes messages sent between clients simpler and brings faster and more stable collaboration.

### Compressed data sent through collaboration

Data sent to the server and data received from the server are now compressed and decompressed by the [operations compressor](https://www.npmjs.com/package/@ckeditor/ckeditor5-operations-compressor), using [Protocol Buffers for JavaScript](https://github.com/dcodeIO/ProtoBuf.js/) and custom optimizations.

To provide better compression, changes are no longer sent as soon as they happen, but with a 300ms delay. All changes in the message are compressed together and the collaboration plugin ensures that only a single selection change will be sent per each message.

### Table and media embedding support

Real-time collaborative editing and comments are tested and proved to work with all CKEditor&nbsp;5 components including recently released table and media embed features. All collaboration features should also work with third-party widgets out of the box.

### Other changes

* Updated comment height along with position to avoid a collision after showing up a hidden editor.
* Improved collaboration error messages.
* Use `lodash-es` dependency instead of `ckeditor5-utils` one.


## 10.1.0 (July 18, 2018)

### Features

* [Published Users API](https://ckeditor.com/docs/ckeditor5/latest/features/collaboration/users.html).

### Bug fixes

* Avatars in the presence list are now vertically centered.
* Improved contrast ratio of azure user marker color.
* Create a comment marker only for the first allowed range.

### Other changes

* Normalized Cloud Services URLs. They now work no matter if the schema is provided or not.


## 10.0.1 (June 21, 2018)

### Pending actions manager

All asynchronous actions, like the client-server communication during the collaboration or creating a comment, are now based on the [pending actions plugin](https://ckeditor.com/docs/ckeditor5/latest/api/module_core_pendingactions-PendingActions.html) introduced in [`ckeditor5-core`](https://github.com/ckeditor/ckeditor5-core) v10.1.0. Thanks to it further integration will be much simpler.

### Socket.IO

`Socket.IO` replaced `SocketCluster` as the base communication library, which improved performance and stability. We are also able to support a larger number of users.

### Bug fixes

* Fixed: Users do not see themselves on the presence list after reconnecting.
* Fixed: Avatars display in low quality on Microsoft Edge.
* Fixed: Comment overlaps the other one after restoring the marker.
* Fixed: Comments collision in the sidebar.
* Fixed: Comment thread cannot be added after blurring input.
* Fixed: Editor crashes after editing a comment twice.
* Fixed: Errors after one hour of editing.
* Fixed: Cannot remove a comment thread when the selection is not in the editor after the initialization.


## 10.0.0 (April 25, 2018)

### Initial module

Introduces:
* Collaboration editing plugin.
* Comments plugin.
* User presence list plugin.
