/**
 * @license Copyright (c) 2003-2024, CKSource Holding sp. z o.o. All rights reserved.
 * For licensing, see LICENSE.md or https://ckeditor.com/legal/ckeditor-oss-license
 */
/**
 * @module real-time-collaboration/presencelist
 * @publicApi
 */
import { ContextPlugin } from 'ckeditor5/src/core.js';
import Sessions from './realtimecollaborativeediting/sessions.js';
import PresenceListUI from './presencelist/presencelistui.js';
/**
 * The `PresenceList` plugin provides a UI which displays all {@link module:collaboration-core/users~Users users} that are
 * currently connected to the edited document. The users are displayed as a row of avatars.
 * The information about the users is provided by {@glink @cs developer-resources/security/token-endpoint#user CKEditor Cloud Services}.
 *
 * The presence list UI collapses to a dropdown if six or more users are connected.
 */
export default class PresenceList extends ContextPlugin {
    /**
     * @inheritDoc
     */
    static get requires(): readonly [typeof Sessions, typeof PresenceListUI];
    /**
     * @inheritDoc
     */
    static get pluginName(): "PresenceList";
}
